#include <string>
#include <vector>
#include "stopos.h"
#include "wutils.h"
#include "stopos_key.h"

stopos_key::stopos_key()
{
  this->set(0,"");
}

stopos_key::stopos_key(const std::string & s)
{
  std::vector <std::string> v;
  v = split(v,s,keysep);
  this->value = v[0];
  if (v.size()>1)
    this->slot = v[1];
}

void stopos_key::impossible()
{
  this->value="%%%%";
}

void stopos_key::increment(void)
{ // notused
  int p = this->value.size();
  while(1)
  {
    p--;
    if (this->value[p] == lastchar)
    {
      this->value[p] = firstchar;
      if (p == 0)
      {
	this->value = firstchar + this->value;
	p = 1;
      }
    }
    else
    {
      this->value[p] ++;
      break;
    }
  }
}

std::string stopos_key::str(void) const
{
  if (this->slot == "")
    return value;

  return this->value+keysep+this->slot;
}

std::string stopos_key::get_key(void) const
{
  return this->value;
}

std::string stopos_key::get_slot(void) const
{
  return this->slot;
}

bool stopos_key::operator==(const stopos_key &k) const
{
  return k.value == this->value;
}

bool stopos_key::operator!=(const stopos_key &k) const
{
  return k.value != this->value;
}

