#ifndef FLATFILE_POOL_H
#define FLATFILE_POOL_H
#include "stopos_pool.h"
#include "stopos_key.h"
#include "stopos.h"

class flatstatusrecord: statusrecord
{
  longuint nextd;
};

class flatfile_pool: public stopos_pool
{
  private:
    int ff;    // handle of file to be used

    int get_record(std::string &r, const std::string &k, const std::string &l);
    int put_record(const std::string &r, const std::string &k,const std::string &l);
    int remove_record(const stopos_key &k);
    int write_string(const std::string &r,off_t p);
    int read_string(std::string &r,off_t p);

    const static int STATUSTOOLONG = 101;

    const static char deleted = 'd';
    const static char exists  = '_';

    std::string get_slot(const std::string &k);
    off_t strtoloc(const std::string &k);

  public:
    flatfile_pool();
    int create_db(const std::string &dbname);
    int purge_db(void);
    int open_db(void);
    int close_db(void);
    void dump_db(void);
};

#endif
