#ifndef GDBM_POOL_H
#define GDBM_POOL_H
#include <string>
#include "gdbm.h"
#include "stopos_key.h"
#include "stopos_pool.h"
#include "stopos.h"
 
class gdbm_pool : public stopos_pool
{
  private:
    GDBM_FILE dbf;          // handle for access database
    //static const int sync = GDBM_SYNC;
    static const int sync = 0;

    int get_record(std::string &r,const std::string &k,const std::string &l);
    int put_record(const std::string &r,const std::string &k,const std::string &l);
    int remove_record(const stopos_key &k);

  public:
    // constructor ()
    gdbm_pool();

    // destructor

    ~gdbm_pool();


    int create_db(const std::string &dbname);
    int purge_db(void);

    int open_db(void);
    int close_db(void);

    void dump_db(void);

};

#endif
