#ifndef FILES_POOL_H
#define FILES_POOL_H
#include "stopos_pool.h"
#include "stopos_key.h"
#include "stopos.h"

class files_pool: public stopos_pool
{

  private:

    int get_record(std::string &r, const std::string &k, const std::string &l);
    int put_record(const std::string &r, const std::string &k,const std::string &l);
    int remove_record(const std::string &k, const std::string &l);
    int lockfile;
    std::string lockfilename;

    void create_fname(std::string &fname,const std::string &k);

    const static int NOTDIR = 102;

    std::string key_to_slot(const std::string &k){return "";}

  public:
    files_pool();
    void set_db_name(std::string name);
    int create_db(const std::string &dbname);
    int purge_db(void);
    int open_db(void);
    int close_db(void);
    void dump_db(void);
};
#endif
